var SCREEN_WIDTH = 580;
var SCREEN_HEIGHT = 756;
var canvas;
var context;
var scalerate = 1;
var layer0,layer1;
var context0,context1;
var img = new Image();
img.src = "pat.gif";
var title = new Image();
title.src = "title.gif";
var hanabira = new Image();
hanabira.src = "hanabira.gif";
var img_home = new Image();
img_home.src = "homebutton.gif";

// フレームレート
var FPS = 30;
// マウス位置
var mouse = {x:0,y:0};
// タッチデバイス
var touchdev = false;
// イベント関数
var timer_func = new Function();
timer_func = null;
var next_func = new Function();
next_func = null;
var click_func = new Function();
click_func = null;
var release_func = new Function();
release_func = null;

window.onload = function()
{
	if( navigator.userAgent.indexOf('iPhone') > 0
		|| navigator.userAgent.indexOf('iPod') > 0
		|| navigator.userAgent.indexOf('iPad') > 0
		|| navigator.userAgent.indexOf('Android') > 0) {
		touchdev = true;
	}
	if( touchdev ){
		scalerate = Math.min(window.innerWidth/SCREEN_WIDTH, window.innerHeight/SCREEN_HEIGHT);
	}

	// キャンバス
	canvas = document.getElementById('canvas');		// canvas要素を取得
	canvas.width = SCREEN_WIDTH;
	canvas.height = SCREEN_HEIGHT;
	canvas.style.width = SCREEN_WIDTH*scalerate+'px';
	canvas.style.height = SCREEN_HEIGHT*scalerate+'px';
	
	context = canvas.getContext('2d');
	
	if( touchdev ){
		canvas.ontouchstart = touchStartListner;
		canvas.ontouchend = touchEndListner;
	}else{
		// マウス
		canvas.onmousedown = mouseDownListner;
		canvas.onmouseup = mouseUpListner;
	}
	
	// ゲーム初期化
	init_game();
	// タイマー用ループ開始
	frame_loop();
	// タイトル画面
	start_title();
}

function frame_loop() {
	if( timer_func != null ) timer_func();
//	requestAnimationFrame( frame_loop );
	setTimeout( frame_loop, 1000/FPS ); // 再帰
}
function mouseDownListner(e) {
	if( click_func != null ){ adjustXY(e); click_func(); }
}
function mouseUpListner(e) {
	if( release_func != null ){ adjustXY(e); release_func(); }
}
function touchStartListner(e) {
	if( click_func != null ){
		var rect = e.target.getBoundingClientRect();
		mouse.x=e.touches[0].pageX-rect.left;
		mouse.y=e.touches[0].pageY-rect.top;
		if( scalerate>0 ){
			mouse.x /= scalerate;
			mouse.y /= scalerate;
		}
		click_func();
	}
	e.preventDefault();
}
function touchEndListner(e) {
}

// マウス座標用
function adjustXY(e) {
	var rect = e.target.getBoundingClientRect();
	if( scalerate>0 ){
		mouse.x = (e.clientX-rect.left)/scalerate;
		mouse.y = (e.clientY-rect.top)/scalerate;
	}
}

///////////////////////////////////////////////////

// ゲーム用変数
var game = new Object();
var player = new Array();

var MOVE_SPEED = 5;
var UPSET_SPEED = 5;

// 札オブジェクト
var FN_TE = 0;
var FN_GET = 16;
var FN_BA = 112;
var FN_YAMA = 160;
var FN_MOVE = 164;
var FN_MAX = 172;
var fuda = new Array();

// 札の種類（カス・短冊・タネ・五光）
var ftype = [0,0,1,3, 0,0,1,2, 0,0,1,3, 0,0,1,2, 0,0,1,2, 0,0,1,2, 0,0,1,2, 0,0,2,3, 0,0,1,2, 0,0,1,2, 0,1,2,3, 0,0,0,3];
// 札の価値
var fval = [3,3,6,9,2,2,6,3,3,3,6,9,1,1,2,2,1,1,2,2,2,2,6,5,2,2,3,5,2,2,3,8,2,2,6,5,2,2,6,5,1,2,2,4,2,2,2,8];

var FUDA_W = 70;
var FUDA_H = 113;
var YOHAKU = 4;	// 上下余白
var POS0 = 14;
var POS1 = 139;
var POS2 = 264;
var POS3 = 389;
var POS4 = 514;
var POS5 = 639;

// 札の描画
function draw_fuda()
{
	var i,who,pat,px,py,sx,sy;

	 // 画面をクリア
//	context.clearRect(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	context.fillStyle = 'rgb(144,128,96)';
	context.fillRect(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	
	// home
	context.drawImage(img_home, 0,0,48,48,8,8,48,48 );

	// 円
	context.fillStyle = 'rgb(72,64,48)';
	context.beginPath();
	context.arc(43,450, 82, 0, Math.PI*2, false);
	context.fill();
	
	// 文
	context.fillStyle = 'rgb(255,255,255)';
	context.textAlign = "center";
	context.font = "22px sans-serif";
	context.fillText(game.mon+"文", 45, 490);

	// 月札
	pat = game.month*4;
	sx = (pat%10)*72;
	sy = Math.floor(pat/10)*114;
	context.drawImage(img, sx,sy, FUDA_W, FUDA_H, 27,410, FUDA_W/2, FUDA_H/2 );
	context.font = "12px sans-serif";
	context.fillText(tuki_name[game.month], 45, 406 );

	for( i=0; i<FN_MAX; i++ ){
		if( !fuda[i].exist ) continue;
		var w = FUDA_W;
		var h = FUDA_H;
		pat = fuda[i].pat;
		if( fuda[i].ura ) pat=48;
		sx = (pat%10)*72;
		sy = Math.floor(pat/10)*114;
		px = fuda[i].px;
		py = fuda[i].py;
		if( fuda[i].per>0 ){
			 w = FUDA_W*fuda[i].per/100;
			 px += (FUDA_W-w)/2;
		}
		if( fuda[i].cursor ){
			if( Math.floor(game.blink/4)%3>0 ){
				context.drawImage(img, 648, 456, FUDA_W+4, FUDA_H+4, px-2, py-2, w+4, h+4 );
			}
		}
		context.drawImage(img, sx, sy, FUDA_W, FUDA_H, px, py, w, h );
	}
	// 数字
	context.fillStyle = 'rgb(255,255,255)';
	context.font = "10px 'Verdana'";
	context.textAlign = "left";
	for( who=0; who<2; who++ ){
		for( i=0; i<4; i++ ){
			if( player[who].type_cnt[i]==0 ) continue;
			py = player[who].ty[i]-2; // : player[who].ty[i]+FUDA_H+11;
			context.fillText(player[who].type_cnt[i], player[who].tx[i], py);
		}
	}
}

///////////////////////////////////////////////////

function init_game(){
	var i,j;
	for( i=0; i<FN_MAX; i++ ){
		fuda[i] = new Object();
	}
	game.yama = new Array();
	for( i=0; i<48; i++ ){
		game.yama[i] = i;
	}
	shuffle();
		
	game.awase = new Array();
	for( i=0; i<4; i++ ){
		game.awase[i] = new Object;	// 合わせた札情報（四枚、元位置、移動先）
	}
	game.fuda_open = false;
	
	for( i=0; i<2; i++ ){
		player[i] = new Object();
		
		// タイプ別の数字表示位置
		player[i].tx = new Array();
		player[i].ty = new Array();
		
		// 種類ごとの枚数
		player[i].type_cnt = [0,0,0,0];	// 種類ごとの枚数
		player[i].type_pat = new Array();	// 種類ごとの取った札リスト
		for( j=0; j<4; j++ ){
			player[i].type_pat[j] = new Array();
		}
		player[i].type_pos = [0,0,0,0];	// 枚数表示の位置
	
		// 役関係のフラグ
		player[i].ino_c=0;
		player[i].aka_c=0;
		player[i].ao_c=0;
		player[i].kik_c=0;
		player[i].ame_c=0;
	
		// 取った札リスト
		player[i].getlist = new Array();
		player[i].getlist_cnt = 0;

		// 札48枚の取ったフラグ
		player[i].getflg = new Array();

		// 役リスト
		player[i].new_yaku = new Array();
		player[i].old_yaku = new Array();
	}
}
// 役
var YK_KASU=0;
var YK_TAN=1;
var YK_TANE=2;
var YK_INO=3;
var YK_AKA=4;
var YK_AO=5;
var YK_SAN=6;
var YK_AME=7;
var YK_YON=8;
var YK_GO=9;
var YK_TUKI=10;
var YK_OYA=11;
var YK_MAX=12;
var yaku_name = ["カス","短冊","タネ","猪鹿蝶","赤短","青短","三光","雨四光","四光","五光","月札","親権"];
var tuki_name = ["松","梅","桜","藤","菖蒲","牡丹","萩","坊主","菊","紅葉","雨","桐"];

// ゲーム開始
function start_game()
{
	game.mon = 10;
	game.oya = Math.floor(Math.random()*2);
	game.ban = game.oya;
	game.month = 0;
	
	start_oneplay();
}

// 一勝負の開始
function start_oneplay()
{
	var i,j,who;
	// 札を消す
	for( i=0; i<FN_MAX; i++ ){
		fuda[i].exist = false;
		fuda[i].px = 0;
		fuda[i].py = 0;
		fuda[i].pat = 0;
		fuda[i].per = 0;	// 横幅
		fuda[i].cursor = false;
		fuda[i].ss = false;	// 取れる札
		fuda[i].upset = false;	// ひっくり返しフラグ
	}
	// シャッフル
	while( !shuffle() ){
	}
	game.yamapos = 0;
	game.winner = -1;
	
	// プレイヤー
	for( who=0; who<2; who++ ){
		player[who].tefuda_c = 8;	// 手札残り枚数
		player[who].getlist_cnt = 0;	// 取った枚数
		// スートごとの取った枚数
		for( i=0; i<4; i++ ){
			player[who].type_cnt[i] = 0;
		}
		// 種類(カス・タン・タネ)ごとの枚数
		for( i=0; i<4; i++ ){
			for( j=0; j<24; j++ ){
				player[who].type_pat[i][j] = 0;
			}
		}
		// 取った札フラグ
		for( i=0; i<48; i++ ){
			player[who].getflg[i] = 0;
		}
		// 役関係のフラグ
		player[who].ino_c=0;
		player[who].aka_c=0;
		player[who].ao_c=0;
		player[who].kik_c=0;
		player[who].ame_c=0;
		// 役リスト
		for( i=0; i<YK_MAX; i++ ){
			player[who].new_yaku[i] = 0;
			player[who].old_yaku[i] = 0;
		}
	}
	// 山
	for( i=0; i<4; i++ ){
		fuda[FN_YAMA+i].exist = true;
		fuda[FN_YAMA+i].ura = true;
	}
	
	fuda_position();
	start_deal();
}

// シャッフル
function shuffle(){
	var i;
	for( i=0; i<48; i++ ){
		var r = Math.floor(Math.random()*48);
		var tmp=game.yama[i]; game.yama[i]=game.yama[r]; game.yama[r]=tmp;
	}
	var fc=[[0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0]];
	var fp=[0,0,0,0,1,1,1,1,2,2,2,2,0,0,0,0,1,1,1,1,2,2,2,2];
	for( i=0; i<24; i++ ){
		var p = fp[i];
		var s = Math.floor(game.yama[i]/4);
		fc[p][s]++;
	}
	var ret = true;
	for( i=0; i<3; i++ ){
		for( j=0; j<12; j++ ){
			if( fc[i][j]>=3 ) ret=false;
		}
	}
	return ret;
}

// 札の位置修正
function fuda_position(){
	var who,i,n,n2;
	for( who=0; who<2; who++ ){
		for( i=0; i<8; i++ ){
			n = FN_TE+who*8+i;
			fuda[n].px = YOHAKU+i*FUDA_W;
			fuda[n].py = (who==0)?POS4:POS1;
		}
		for( i=0; i<48; i++ ){
			n = FN_GET+who*48+i;
			fuda[n].px = YOHAKU;
			fuda[n].py = (who==0)?POS5:POS0;
		}
	}
	for( i=0; i<24; i++ ){
		n = FN_BA + i;
		fuda[n].px = 100+Math.floor(i/2)*78;
		fuda[n].py = (i%2)?POS3:POS2;
		n2 = n+24;
		fuda[n2].px = fuda[n].px + 4;
		fuda[n2].py = fuda[n].py + 10;
	}
	for( i=0; i<4; i++ ){
		n = FN_YAMA + i;
		fuda[n].px = 10-i;
		fuda[n].py = 270-i*2;
	}
}
// 場札位置の修正
function ba_position(){
	for( var i=0; i<24; i++ ){
		var n = FN_BA + i;
		fuda[n].px = 80+Math.floor(i/2)*70;
		fuda[n].py = (i%2)?POS3:POS2;
		var n2 = n+24;
		fuda[n2].px = fuda[n].px + 4;
		fuda[n2].py = fuda[n].py + 10;
	}
}

// 配る
function start_deal()
{
	var i;
	var dest = 0;
	var ko = (game.oya==0)?1:0;
	var mode = 0;
	if( !fuda[FN_BA+4].exist ) mode=5;
	if( !fuda[FN_TE+ko*8+4].exist ) mode=4;
	if( !fuda[FN_TE+game.oya*8+4].exist ) mode=3;
	if( !fuda[FN_BA].exist ) mode=2;
	if( !fuda[FN_TE+ko*8].exist ) mode=1;
	if( !fuda[FN_TE+game.oya*8].exist ) mode=0;
	switch( mode ){
		case 0: dest=FN_TE+game.oya*8; break;
		case 1: dest=FN_TE+ko*8; break;
		case 2: dest=FN_BA; break;
		case 3: dest=FN_TE+game.oya*8+4; break;
		case 4: dest=FN_TE+ko*8+4; break;
		case 5: dest=FN_BA+4; break;
	}
	game.upset = true;
	if( !game.fuda_open ){
		if( dest>=FN_TE+8 && dest<FN_TE+16 ) game.upset = false;
	}
	for( i=0; i<4; i++ ){
		var n = FN_MOVE+i;
		fuda[n].exist = true;
		fuda[n].pat = game.yama[game.yamapos];
		fuda[n].ura = true;
		fuda[n].ox = fuda[FN_YAMA+3].px;
		fuda[n].oy = fuda[FN_YAMA+3].py;
		fuda[n].dest = dest+i;
		fuda[n].upset = game.upset;
		game.yamapos++;
	}
	game.cnt = 0;
	next_func = after_deal_move;
	timer_func = move_fuda;
}

function after_deal_move(){
	if( game.upset ){
		game.cnt = 0;
		timer_func = upset;
		next_func = after_deal;
	}else{
		timer_func = null;
		after_deal();
	}
}

function after_deal(){
	copy_move();

	if( !fuda[FN_BA+4].exist ){
		start_deal();
	}else{
		timer_func = null;
		game.ban = game.oya;
		start_player();
	}
}

// 札の移動
function move_fuda()
{
	game.cnt++;

	var i;
	for( i=0; i<4; i++ ){
		var n = FN_MOVE+i;
		if( !fuda[n].exist ) continue;
		var d = fuda[n].dest;
		fuda[n].px = fuda[n].ox + (fuda[d].px-fuda[n].ox)*game.cnt/MOVE_SPEED;
		fuda[n].py = fuda[n].oy + (fuda[d].py-fuda[n].oy)*game.cnt/MOVE_SPEED;
	}
	draw_fuda();
	
	if( game.cnt<MOVE_SPEED ) return;
	
	timer_func = null;
	if( next_func != null ) next_func();
}

// 移動、ひっくり返し後に札をコピーして消す
function copy_move()
{
	for( var i=0; i<4; i++ ){
		var n = FN_MOVE+i;
		if( !fuda[n].exist ) continue;
		fuda[n].exist = false;
		var d = fuda[n].dest;
		fuda[d].exist = true;
		fuda[d].pat = fuda[n].pat;
		fuda[d].stat = fuda[n].stat;
		fuda[d].ura = fuda[n].ura;
	}
	draw_fuda();
}

// 札をひっくり返す
function upset()
{
	game.cnt++;

	var p = 0;
	var ura = true;
	switch( game.cnt ){
		case 1: p=50; break;
		case 2: p=10; break;
		case 3: p=40; ura=false; break;
		case 4: p=80; ura=false; break;
		case 5: p=0; ura=false; break;
	}

	var i;
	for( i=0; i<FN_MAX; i++ ){
		var n = i;//FN_MOVE+i;
		if( !fuda[n].exist ) continue;
		if( !fuda[n].upset ) continue;
		fuda[n].ura = ura;
		fuda[n].per = p;
	}
	draw_fuda();
	
	if( game.cnt<UPSET_SPEED ) return;
	
	for( i=0; i<FN_MAX; i++ ){
		fuda[i].upset = false;
	}

	timer_func = null;
	if( next_func != null ) next_func();
}

///////////////////////////////////////

// ウエイト
function waiting(){
	game.cnt++;
	if( game.cnt>=game.wait ){
		timer_func = null;
		if( next_func != null ) next_func();
	}
}

///////////////////////////////////////

function start_player(){
	game.sute_fn = 0;
	if( game.ban==0 ){
		start_man();
	}else{
		start_com();
	}
}

function start_com()
{
	game.want = 0;
	set_com_sute();	// game.sute_fn を決める
	
	var wc = 0;
	if( game.want<14 ) wc = 5;
	if( game.want<10 ) wc = 10;
	if( game.want<5 ) wc = 20;
	if( game.want<1 ) wc = 20 + Math.random()*50;
	if( player[1].tefuda_c==1 ) wc = 5;
	
	game.cnt = 0;
	game.wait = wc;
	timer_func = waiting;
	next_func = com_mekuri;
}

function com_mekuri(){
	var fn = game.sute_fn;
	fuda[fn].upset = true;
	
	game.cnt = 0;
	timer_func = upset;
	next_func = com_sute;
}

function com_sute(){
	var fn = game.sute_fn;
	var dest = get_awase_fn(fuda[fn].pat);
	if( dest<0 ){
		var m=-1;
		dest = FN_BA;
		for( var i=0; i<24; i++ ){
			var n = FN_BA+i;
			if( !fuda[n].exist ) continue;
			if( fuda[n].ss ){
				if( fval[fuda[n].pat]>m ){
					m = fval[fuda[n].pat];
					dest = n+24;
				}
			}
		}
	}
	timer_func = null;
	start_sute( dest );
}

///////////////////////////////////////

function start_man(){
	timer_func = null;
	click_func = sute_click;
}

function sute_click()
{
	if( mouse.x<56 && mouse.y<56 ){
		location.href="http://gamedesign.jp/";
	}

	var i,fn=-1;
	for( i=0; i<8; i++ ){
		var n = FN_TE + game.ban*8 + i;
		if( !fuda[n].exist ) continue;
		if( mouse.x<fuda[n].px || mouse.x>=fuda[n].px+FUDA_W ) continue;
		if( mouse.y<fuda[n].py || mouse.y>=fuda[n].py+FUDA_H ) continue;
		fn = n;
	}
	if( fn<0 ) return;

	game.sute_fn = fn;
	var dest = get_awase_fn(fuda[fn].pat);
	
	timer_func = null;
	click_func = null;
	if( dest<0 ){
		start_sute_select();
	}else{
		start_sute( dest );
	}
}

// 合わせる場所を返す（二個以上のときはマイナス）
function get_awase_fn( pat )
{
	var ret = -1;
	var i,n,c=0;
	for( i=0; i<24; i++ ){
		fuda[FN_BA+i].ss = false;
		fuda[FN_BA+i].cursor = false;
	}
	var month = Math.floor(pat/4);
	var kasudake = true;	// カスだけフラグ
	for( i=0; i<24; i++ ){
		n = FN_BA+i;
		if( !fuda[n].exist ) continue;
		if( Math.floor(fuda[n].pat/4)==month ){
			if( !fuda[n+24].exist ){
				fuda[n].ss = true;
				if( ftype[fuda[n].pat]!=0 ) kasudake = false;
				c++;
				ret = n+24;
			}
		}
	}
	if( c==2 ){
		if( kasudake ) c=1;
	}	
	if( c==1 ) return ret;
	if( c>=2 ) return -1;

	// 一枚もない場合
	for( i=0; i<24; i++ ){
		n = FN_BA+i;
		if( fuda[n].exist ) continue;
		ret = n;
		break;
	}
	return ret;
}

// 捨て札時の選択開始
function start_sute_select()
{
	var i;
	for( i=0; i<24; i++ ){
		var n = FN_BA+i;
		if( fuda[n].ss ) fuda[n].cursor = true;
	}
	game.blink=0;
//	draw_fuda();
	timer_func = blinking;
	click_func = click_sute_select;
}

// カーソル点滅
function blinking(){
	game.blink++;
	draw_fuda();
}

// 選択カーソル札をクリック
function click_sute_select(){
	var i,fn=-1;
	for( i=0; i<24; i++ ){
		var n = FN_BA + i;
		if( !fuda[n].exist ) continue;
		if( !fuda[n].cursor ) continue;
		if( mouse.x<fuda[n].px || mouse.x>=fuda[n].px+FUDA_W ) continue;
		if( mouse.y<fuda[n].py || mouse.y>=fuda[n].py+FUDA_H ) continue;
		fn = n;
	}
	for( i=0; i<24; i++ ){
		fuda[FN_BA+i].cursor = false;
	}
	// キャンセル
	if( fn<0 ){
		draw_fuda();
		start_man();
		return;
	}
	
	var dest = fn+24;;
	
	timer_func = null;
	click_func = null;
	start_sute( dest );
}

// 捨てる時の移動
function start_sute( dest )
{
	var n = FN_MOVE;
	fuda[n].exist = true;
	fuda[n].pat = fuda[game.sute_fn].pat;
	fuda[n].ura = false;
	fuda[n].ox = fuda[game.sute_fn].px;
	fuda[n].oy = fuda[game.sute_fn].py;
	fuda[n].dest = dest;
	// 元の札消す
	fuda[game.sute_fn].exist = false;

	// 場札位置修正
	if( dest>=FN_BA+12 && dest<FN_BA+24 ){
		ba_position();
	}
	
	game.upset = false;
	game.cnt = 0;
	next_func = after_sute;
	timer_func = move_fuda;
}

// 捨て札後
function after_sute()
{
	copy_move();
	
	game.cnt = 0;
	game.wait = 5;
	timer_func = waiting;
	next_func = start_mekuri;
}

// 山札めくる
function start_mekuri()
{
	var n = FN_MOVE;
	fuda[n].exist = true;
	fuda[n].pat = game.yama[game.yamapos];
	fuda[n].ura = true;
	fuda[n].ox = fuda[n].px = fuda[FN_YAMA+3].px;
	fuda[n].oy = fuda[n].py = fuda[FN_YAMA+3].py;
	fuda[n].upset = true;
	game.yamapos++;
	
	game.cnt = 0;
	timer_func = upset;
	next_func = after_mekuri;
}

function after_mekuri(){
	game.cnt = 0;
	game.wait = 5;
	timer_func = waiting;
	next_func = start_mekuri_sute;
}

// めくった札を移動する
function start_mekuri_sute()
{
	var i,n;
	var fn = FN_MOVE;
	var dest = get_awase_fn(fuda[fn].pat);
	if( dest<0 ){
		if( game.ban==0 ){
			for( i=0; i<24; i++ ){
				n = FN_BA+i;
				if( fuda[n].ss ) fuda[n].cursor = true;
			}
			game.blink = 0;
			draw_fuda();
			timer_func = blinking;
			click_func = click_mekuri_sute_select;
			return;
		}else{
			dest = FN_BA;
			var m = -1;
			for( i=0; i<24; i++ ){
				n = FN_BA+i;
				if( !fuda[n].exist ) continue;
				if( fuda[n].ss ){
					if( fval[fuda[n].pat]>m ){
						m = fval[fuda[n].pat];
						dest = n+24;
					}
				}
			}
		}
	}

	fuda[fn].dest = dest;
	
	// 場札位置修正
	if( dest>=FN_BA+12 && dest<FN_BA+24 ){
		ba_position();
	}

	game.cnt = 0;
	timer_func = move_fuda;
	next_func = after_mekuri_sute;
}

// 選択カーソル札をクリック
function click_mekuri_sute_select(){
	var i,fn=-1;
	for( i=0; i<24; i++ ){
		var n = FN_BA + i;
		if( !fuda[n].exist ) continue;
		if( !fuda[n].cursor ) continue;
		if( mouse.x<fuda[n].px || mouse.x>=fuda[n].px+FUDA_W ) continue;
		if( mouse.y<fuda[n].py || mouse.y>=fuda[n].py+FUDA_H ) continue;
		fn = n;
	}
	if( fn<0 ) return;
	
	for( i=0; i<24; i++ ){
		fuda[FN_BA+i].cursor = false;
	}
	
	var dest = fn+24;
	fuda[FN_MOVE].dest = dest;
	
	game.cnt = 0;
	timer_func = move_fuda;
	click_func = null;
	next_func = after_mekuri_sute;
}

function after_mekuri_sute(){
	copy_move();
	
	game.cnt = 0;
	game.wait = 5;
	timer_func = waiting;
	next_func = tefuda_press;
}

// 手札詰める、取り札の位置を修正
function tefuda_press()
{
	var i,n,p,c=0;
	var who = game.ban;
	var pat = new Array();
	for( i=0; i<8; i++ ){
		n = FN_TE+who*8+i;
		if( fuda[n].exist ){
			pat[c] = fuda[n].pat;
			c++;
		}
	}
	var ura = true;
	if( game.fuda_open || who==0 ) ura=false;
	for( i=0; i<8; i++ ){
		n = FN_TE+who*8+i;
		if( i<c ){
			fuda[n].pat = pat[i];
			fuda[n].exist = true;
			fuda[n].ura = ura;
		}else{
			fuda[n].exist = false;
		}
	}
	player[who].tefuda_c = c;	// 手札枚数
	
	// 合わせた札
	c = 0;
	for( i=0; i<24; i++ ){
		n = FN_BA+24+i;
		if( fuda[n].exist ){
			game.awase[c].fn = n;
			c++;
			game.awase[c].fn = n-24;
			c++;
		}
	}
	game.awase_c = c;
	
	// 取った札
	for( i=0; i<game.awase_c; i++ ){
		n = game.awase[i].fn;
		game.awase[i].dest = FN_GET+who*48+player[who].getlist_cnt;
		player[who].getlist[ player[who].getlist_cnt ] = fuda[n].pat;
		player[who].getlist_cnt++;
	}
	// タイプ別カウント
	var tc = [0,0,0,0];
	for( i=0; i<player[who].getlist_cnt; i++ ){
		p = player[who].getlist[i];
		tc[ ftype[p] ]++;
	}
	// タイプ数
	var ts=0;
	for( i=0; i<4; i++ ){
		if( tc[i]>0 ) ts++;
	}
	// 取札表示の全幅
	var aw = SCREEN_WIDTH-YOHAKU*2;
	aw -= ts*FUDA_W;
	aw -= (ts-1)*5;	// タイプ間の間隔
	// 有効札枚数
	var c=0;
	for( i=0; i<4; i++ ){
		if( tc[i]>0 ) c += (tc[i]-1);
	}
	// 札間隔
	var st = 20;
	if( c>0 ) st=Math.floor(aw/c);
	if( st>20 ) st=20;
	// 開始位置
	var x = SCREEN_WIDTH-YOHAKU-(ts*FUDA_W+(ts-1)*5+c*st);
	// タイプ別開始位置
	var tx=[x,0,0,0];
	for( i=0; i<3; i++ ){
		if( tc[i]>0 ){
			x += FUDA_W+(tc[i]-1)*st+5;
		}
		tx[i+1] = x;
	}
	// Y位置
	var ty=[0,0,0,0];
	for( i=0; i<4; i++ ){
		ty[i] = (who==0)?POS5:POS0;
	}
	var st2 = st;	// カス用
	
	// 残り四枚になったら二段使用する
	if( player[who].tefuda_c<=4 ){
		if( tc[0]>0 ) ts--;	// カスのぶん抜く
		aw = SCREEN_WIDTH-YOHAKU*2;
		aw -= ts*FUDA_W;
		aw -= (ts-1)*5;	// タイプ間の間隔
		c=0;
		for( i=1; i<4; i++ ){
			if( tc[i]>0 ) c+=(tc[i]-1);
		}
		st = 28;
		if( c>0 ) st=Math.floor(aw/c);
		if( st>28 ) st=28;
		x = SCREEN_WIDTH-YOHAKU-(ts*FUDA_W+(ts-1)*5+c*st);
		tx[1] = x;
		for( i=1; i<3; i++ ){
			if( tc[i]>0 ){
				x += FUDA_W+(tc[i]-1)*st+5;
			}
			tx[i+1] = x;
		}
		for( i=0; i<4; i++ ){
			ty[i] = (who==0)?POS5:POS0;
			if( i==0 ) ty[i] = (who==0)?POS4:POS1;
		}
		aw = SCREEN_WIDTH-YOHAKU*2-player[who].tefuda_c*FUDA_W-FUDA_W;
		aw -= FUDA_W;
		c=tc[0]-1;
		if( c<0 ) c=0;
		st2 = 20;
		if( c>0 ) st2=Math.floor(aw/c);
		if( st2>20 ) st2=20;
		x = SCREEN_WIDTH-YOHAKU-(FUDA_W+c*st2);
		tx[0] = x;
	}
	
	
	// 数字の表示用
	for( i=0; i<4; i++ ){
		player[who].type_cnt[i] = tc[i];
		player[who].tx[i] = tx[i];
		player[who].ty[i] = ty[i];
	}
	// 札位置の修正
	for( i=0; i<player[who].getlist_cnt; i++ ){
		n = FN_GET+who*48+i;
		var t = ftype[ player[who].getlist[i] ];
		fuda[n].px = tx[t];
		fuda[n].py = ty[t];
		tx[t] += (t==0)?st2:st;
	}
	
	draw_fuda();
	start_awase_move();
}

// 合わせた札を手元に持ってくる
function start_awase_move()
{
	var i,fn,dest=-1;
	for( i=0; i<game.awase_c; i++ ){
		fn = game.awase[i].fn;
		if( fuda[fn].exist ){
			dest = game.awase[i].dest;
			break;
		}
	}
	if( dest<0 ){
		timer_func = null;
		check_yaku();
		return;
	}
	
	var n = FN_MOVE;
	fuda[n].exist = true;
	fuda[n].pat = fuda[fn].pat;
	fuda[n].ura = false;
	fuda[n].ox = fuda[fn].px;
	fuda[n].oy = fuda[fn].py;
	fuda[n].dest = dest;
	// 元札消す
	fuda[fn].exist = false;

	game.cnt = 0;
	next_func = after_awase_move;
	timer_func = move_fuda;
}

function after_awase_move(){
	copy_move();
	start_awase_move();
}

//////////////////////////////////
// 取得後、役チェック
//////////////////////////////////

function check_yaku(){
	var i;
	var ban = game.ban;
	
	// 役関係のフラグ
	player[ban].ino_c=0;
	player[ban].aka_c=0;
	player[ban].ao_c=0;
	player[ban].kik_c=0;
	player[ban].ame_c=0;

	// スートカウント（月札）
	var suit_cnt = [0,0,0,0,0,0,0,0,0,0,0,0,0];
	
	// 取った札リストをもとに、カウントし直す
	for( i=0; i<player[ban].getlist_cnt; i++ ){
		var pat = player[ban].getlist[i];
		player[ban].getflg[pat] = 1;
		if( pat==23 || pat==27 || pat==39 ) player[ban].ino_c++;
		if( pat==2 || pat==6 || pat==10 ) player[ban].aka_c++;
		if( pat==22 || pat==34 || pat==38 ) player[ban].ao_c++;
		if( pat==35 ) player[ban].kik_c=1;
		if( pat==43 ) player[ban].ame_c=1;
		var s = Math.floor(pat/4);
		suit_cnt[s]++;
	}
	
	// 新しい役
	for( i=0; i<YK_MAX; i++ ){
		player[ban].new_yaku[i] = 0;
	}
	
	// 役チェック
	if( player[ban].type_cnt[0]+player[ban].kik_c >= 10 ){
		player[ban].new_yaku[YK_KASU] = player[ban].type_cnt[0]+player[ban].kik_c-9;
	}
	if( player[ban].type_cnt[1] >= 5 ) player[ban].new_yaku[YK_TAN] = player[ban].type_cnt[1]-4;
	if( player[ban].type_cnt[2] >= 5 ) player[ban].new_yaku[YK_TANE] = player[ban].type_cnt[2]-4;
	if( player[ban].ino_c == 3 ) player[ban].new_yaku[YK_INO] = 5;
	if( player[ban].aka_c == 3 ) player[ban].new_yaku[YK_AKA] = 6;
	if( player[ban].ao_c == 3 ) player[ban].new_yaku[YK_AO] = 6;
	if( player[ban].type_cnt[3]==3 && player[ban].ame_c==0 ) player[ban].new_yaku[YK_SAN] = 6;
	if( player[ban].type_cnt[3]==4 ){
		if( player[ban].ame_c ) player[ban].new_yaku[YK_AME] = 8; else player[ban].new_yaku[YK_YON] = 10;
	}
	if( player[ban].type_cnt[3]==5 ) player[ban].new_yaku[YK_GO] = 15;
	if( suit_cnt[game.month]==4 ) player[ban].new_yaku[YK_TUKI] = 4;

	var f=0;
	for( i=0; i<YK_MAX; i++ ){
		if( player[ban].old_yaku[i] < player[ban].new_yaku[i] ){
			f=1;
		}
	}
	
	if( f==0 ){
		// 役が出来なかった
		after_player();
	}else{
		// 役が出来た
		game.winner = ban;
		start_yaku();
	}
	
}

// 役表示の札リスト
var yakufuda=new Array();
var yakufuda_c = 0;
var agariyaku = 0;
var agarimon = 0;

function start_yaku()
{
	var i,p;
	var n=-1;
	var ban = game.ban;
	for( i=0; i<YK_MAX; i++ ){
		if( player[ban].old_yaku[i] < player[ban].new_yaku[i] ){
			player[ban].old_yaku[i] = player[ban].new_yaku[i];
			n = i;
			break;
		}
	}
	// もう新しい役がない
	if( n<0 ){
		if( player[ban].tefuda_c==0 ){
			start_sum();
		}else{
			if( ban==0 ) koi_man(); else koi_com();
		}
		return;
	}
	// 新しい役があった

	// 札
	var c=0;
	if( n==YK_KASU ){
		for( i=0; i<player[ban].getlist_cnt; i++ ){
			p = player[ban].getlist[i];
			if( ftype[p]!=0 ) continue;
			yakufuda[c] = p;
			c++;
		}
		if( player[ban].kik_c ){
			yakufuda[c] = 35;
			c++;
		}
	}else if( n==YK_TAN ){
		for( i=0; i<player[ban].getlist_cnt; i++ ){
			p = player[ban].getlist[i];
			if( ftype[p]!=1 ) continue;
			yakufuda[c] = p;
			c++;
		}
	}else if( n==YK_TANE ){
		for( i=0; i<player[ban].getlist_cnt; i++ ){
			p = player[ban].getlist[i];
			if( ftype[p]!=2 ) continue;
			yakufuda[c] = p;
			c++;
		}
	}else if( n==YK_INO ){
		yakufuda[0] = 27;
		yakufuda[1] = 39;
		yakufuda[2] = 23;	c=3;
	}else if( n==YK_AKA ){
		yakufuda[0] = 2;
		yakufuda[1] = 6;
		yakufuda[2] = 10;	c=3;
	}else if( n==YK_AO ){
		yakufuda[0] = 22;
		yakufuda[1] = 34;
		yakufuda[2] = 38;	c=3;
	}else if( n==YK_TUKI ){
		for( i=0; i<4; i++ ){
			yakufuda[i] = game.month*4+i;
		}
		c=4;
	}else{
		for( i=0; i<player[ban].getlist_cnt; i++ ){
			p = player[ban].getlist[i];
			if( ftype[p]!=3 ) continue;
			yakufuda[c] = p;
			c++;
		}
	}
	yakufuda_c = c;
	agariyaku = n;
	agarimon = player[ban].new_yaku[n];
	
	box.w = 10;
	box.h = 10;
	box.mw = 480;
	box.mh = 140;
	timer_func = yakubox;
}

function yakubox(){
	if( !drawbox() ) return;
	
	var px = SCREEN_WIDTH/2-box.mw/2+100;
	var py = SCREEN_HEIGHT/2-55;
	var w = box.mw-100-10;
	var sa = 10;
	if( yakufuda_c>1 ) sa=Math.floor((w-FUDA_W)/(yakufuda_c-1));
	if( sa>FUDA_W ) sa=FUDA_W;
	
	for( var i=0; i<yakufuda_c; i++ ){
		var sx = (yakufuda[i]%10)*72;
		var sy = Math.floor(yakufuda[i]/10)*114;
		context.drawImage(img, sx, sy, FUDA_W, FUDA_H, px, py, FUDA_W, FUDA_H );
		px += sa;
	}
	context.textAlign = "center";
	context.font = "22px sans-serif";
	context.fillStyle = 'rgb(255,255,255)';
	context.fillText(yaku_name[agariyaku],SCREEN_WIDTH/2-box.mw/2+50,SCREEN_HEIGHT/2-box.mh/2+40);
	context.fillText(agarimon+"文",       SCREEN_WIDTH/2-box.mw/2+50,SCREEN_HEIGHT/2-box.mh/2+70);
	
	timer_func = null;
	click_func = yaku_click;
}

function yaku_click(){
	draw_fuda();
	click_func = null;
	start_yaku();
}

/////////////////////////////////
// こいこい man
/////////////////////////////////

function koi_man(){
	box.w = 10;
	box.h = 10;
	box.mw = 400;
	box.mh = 280;
	timer_func = koibox;
}

function koibox(){
	if( !drawbox() ) return;

	context.textAlign = "center";
	context.font = "22px sans-serif";
	context.fillStyle = 'rgb(255,255,255)';
	context.fillText("こいこいしますか？",SCREEN_WIDTH/2,SCREEN_HEIGHT/2-box.mh/4);
	context.fillText("はい",SCREEN_WIDTH/2-box.mw/4,SCREEN_HEIGHT/2+box.mh/4);
	context.fillText("いいえ",SCREEN_WIDTH/2+box.mw/4,SCREEN_HEIGHT/2+box.mh/4);
	context.strokeStyle='#ffffff';
	context.beginPath();
	context.moveTo(SCREEN_WIDTH/2-box.mw*0.45, SCREEN_HEIGHT/2);
	context.lineTo(SCREEN_WIDTH/2+box.mw*0.45, SCREEN_HEIGHT/2);
	context.stroke();
	
	timer_func = null;
	click_func = koi_click;
}

function koi_click(){
	if( mouse.x<SCREEN_WIDTH/2-box.mw/2 ) return;
	if( mouse.x>SCREEN_WIDTH/2+box.mw/2 ) return;
	if( mouse.y<SCREEN_HEIGHT/2 ) return;
	if( mouse.y>SCREEN_HEIGHT/2+box.mh/2 ) return;
	
	draw_fuda();
	click_func = null;
	
	if( mouse.x<SCREEN_WIDTH/2 ){
		after_player();
	}else{
		start_sum();
	}
}

/////////////////////////////////
// 次の人へ
/////////////////////////////////

function after_player(){
	game.ban = (game.ban==0)?1:0;
	
	if( player[game.ban].tefuda_c>0 ){
		start_player();
	}else{
		game.cnt=0;
		timer_func = last_wait;
	}
}

// 終局前に少し間をあける
function last_wait(){
	game.cnt++;
	if( game.cnt<30 ) return;
	
	if( game.winner<0 ){
		game.winner = game.oya;
		player[game.oya].old_yaku[YK_OYA] = 6;
	}
	start_sum();
}

/////////////////////////////////
// 合計の表示
/////////////////////////////////

function start_sum(){
	box.w = 10;
	box.h = 10;
	box.mw = 260;
	box.mh = 320;
	timer_func = sumbox;
}

function sumbox(){
	if( !drawbox() ) return;
	
	var w = game.winner;
	var i;
	
	// 三光役の修正
	if( player[w].old_yaku[YK_GO] ){
		player[w].old_yaku[YK_YON]=0;
		player[w].old_yaku[YK_AME]=0;
		player[w].old_yaku[YK_SAN]=0;
	}
	if( player[w].old_yaku[YK_YON] ){
		player[w].old_yaku[YK_SAN]=0;
	}
	if( player[w].old_yaku[YK_AME] ){
		player[w].old_yaku[YK_SAN]=0;
	}
	context.font = "22px sans-serif";
	context.fillStyle = 'rgb(255,255,255)';

	var ox = SCREEN_WIDTH/2-box.mw/2+40;	
	var oy = SCREEN_HEIGHT/2-box.mh/2+50;	
	var c = 0;
	var sum = 0;
	for( i=0; i<YK_MAX; i++ ){
		if( player[w].old_yaku[i] ){
			context.textAlign = "left";
			context.fillText( yaku_name[i], ox, oy+c*30 );
			context.textAlign = "right";
			context.fillText( player[w].old_yaku[i]+"文", ox+170, oy+c*30 );
			sum += player[w].old_yaku[i];
			c++;
		}
	}
	c = 8;
	context.textAlign = "left";
	context.fillText( "合計", ox, oy+c*30 );
	context.textAlign = "right";
	context.fillText( sum+"文", ox+170, oy+c*30 );

	if( w==0 ){
		game.mon_dest = game.mon+sum;
		if( game.mon_dest>50 ) game.mon_dest = 50;
	}else{
		game.mon_dest = game.mon-sum;
		if( game.mon_dest<0 ) game.mon_dest = 0;
	}
	timer_func = null;
	click_func = sum_click;
}

function sum_click(){
	draw_fuda();
	game.cnt=10;
	click_func = null;
	timer_func = add_mon;
}

function add_mon(){
	game.cnt--;
	if( game.cnt>0 ) return;
	game.cnt = 4;
	
	if( game.mon==game.mon_dest ){
		// com札オープン
		for( var i=0; i<8; i++ ){
			fuda[FN_TE+8+i].upset = true;
		}
		game.cnt = 0;
		timer_func = upset;
		next_func = after_add_mon;
	}else{
		if( game.mon<game.mon_dest ){
			game.mon++;
		}else{
			game.mon--;
		}
		draw_fuda();
	}
}

function after_add_mon(){
	timer_func = null;
	click_func = after_sum;
}

function after_sum(){
	click_func = null;
	
	if( game.mon<=0 ){
		game.fuda_open = false;
		
		box.w = 10;
		box.h = 10;
		box.mw = 320;
		box.mh = 80;
		timer_func = gameover;
		return;
	}
	if( game.mon>=50 ){
		if( !game.fuda_open ) game.fuda_open=true;
		start_ending();
		return;
	}
	
	game.month++;
	if( game.month>=12 ) game.month=0;
	game.oya = game.winner;
	start_oneplay();
}

/////////////////////////////////
// ゲームオーバー
/////////////////////////////////

function gameover(){
	if( !drawbox() ) return;
	
	context.textAlign = "center";
	context.font = "22px sans-serif";
	context.fillStyle = 'rgb(255,255,255)';
	context.fillText("G A M E O V E R",SCREEN_WIDTH/2,SCREEN_HEIGHT/2+8);
	
	timer_func = null;
	click_func = gameover_click;
}

function gameover_click(){
	timer_func = null;
	click_func = null;
	
	start_title();
}

/////////////////////////////////
// ダイアログボックス
/////////////////////////////////

var box = {w:0,h:0,mw:0,mh:0};

function drawbox(){
	draw_fuda();
	var cx = SCREEN_WIDTH/2;
	var cy = SCREEN_HEIGHT/2;
	if( box.w<box.mw ){
		box.w+=box.mw/5;
	}else{
		box.h+=box.mh/5;
	}
	context.fillStyle = 'rgba(0,0,0,0.9)';
	context.fillRect(Math.floor(cx-box.w/2), Math.floor(cy-box.h/2), box.w, box.h);

	if( box.h>=box.mh ) return true;
	return false;
}


/////////////////////////////////
// COM思考
/////////////////////////////////

function set_com_sute()
{
	game.want = 0;
	game.sute_fn = FN_TE+game.ban*8;
	
	var ban = game.ban;	
	var i,j,s,fn,n;
	
	// 見え札のカウント
	var suit_c = [0,0,0,0,0,0,0,0,0,0,0,0];
	for( i=8; i<FN_YAMA; i++ ){
		if( !fuda[i].exist ) continue;
		s = Math.floor(fuda[i].pat/4);
		suit_c[s]++;
	}
	
	// 場のカスの数
	var kas_c = [0,0,0,0,0,0,0,0,0,0,0,0];
	for( i=0; i<48; i++ ){
		fn = FN_BA+i;
		if( !fuda[fn].exist ) continue;
		if( ftype[fuda[fn].pat]==0 ){
			s = Math.floor(fuda[fn].pat/4);
			kas_c[s]++;
		}
	}
	
	// 値の高い札を捨てる
	var sute_val = [0,0,0,0,0,0,0,0];
	
	for( i=0; i<player[ban].tefuda_c; i++ ){
		fn = FN_TE+ban*8+i;
		if( !fuda[fn].exist ) continue;
		s = Math.floor(fuda[fn].pat/4);
		var v1 = fval[fuda[fn].pat];
	
		for( j=0; j<24; j++ ){
			var fn2 = FN_BA+j;
			if( !fuda[fn2].exist ) continue;
			if( Math.floor(fuda[fn2].pat/4) != s ) continue;
			var v = v1 + fval[fuda[fn2].pat]*2;
			if( s==game.month ) v+=2;
			// いつでも取れる札は最後
			if( suit_c[s] == 4 ) v = 1;	// 四枚見え
			if( kas_c[s] >= 2 ) v = 2;	// カス二枚
			if( v > sute_val[i] ) sute_val[i] = v;
		}
	}
	n = -1;
	var vmax = 0;
	for( i=0; i<player[ban].tefuda_c; i++ ){
		if( sute_val[i] > vmax ){
			vmax = sute_val[i];
			n = i;
		}
	}
	if( n>=0 ){
		game.want = vmax;
		game.sute_fn = FN_TE+ban*8+n;
		return;
	}

	// 以下、合わせる札が無い場合

	// 四枚見えてる札
	for( i=0; i<player[ban].tefuda_c; i++ ){
		fn = FN_TE+ban*8+i;
		if( !fuda[fn].exist ) continue;
		s = Math.floor(fuda[fn].pat/4);
		if( suit_c[s] == 4 ) n=i;
	}
	if( n>=0 ){
		game.want = 10;
		game.sute_fn = FN_TE+ban*8+n;
		return;
	}
	
	// 価値の低い札
	var min = 999;
	for( i=0; i<player[ban].tefuda_c; i++ ){
		fn = FN_TE+ban*8+i;
		if( !fuda[fn].exist ) continue;
		var v = fval[fuda[fn].pat];
		if( v < min ){
			min = v;
			n = i;
		}
	}
	if( n>=0 ){
		game.want = 1;
		game.sute_fn = FN_TE+ban*8+n;
		return;
	}
}

/////////////////////////////////
// こいこい com
/////////////////////////////////

function koi_com()
{
	var i,j;
	get_kasu = [0,0];
	get_tan = [0,0];
	get_tane = [0,0];
	get_goko = [0,0];
	get_aka = [0,0];
	get_ao = [0,0];
	get_ino = [0,0];
	
	for( i=0; i<FN_YAMA; i++ ){
		var p = -1;
		if( i>=FN_GET && i<FN_GET+48 ) p=0;
		if( i>=FN_GET+48 && i<FN_GET+96 ) p=1;
		if( i>=FN_TE+8 && i<FN_TE+16 ) p=1;
		if( p<0 ) continue;
		
		if( !fuda[i].exist ) continue;
		var pat = fuda[i].pat;
		
		switch( ftype[pat] ){
		case 0: get_kasu[p]++; break;
		case 1: get_tan[p]++; break;
		case 2: get_tane[p]++; break;
		case 3: get_goko[p]++; break;
		default: break;
		}

		if( pat==23 || pat==27 || pat==39 ) get_ino[p]++;
		if( pat==2 || pat==6 || pat==10 ) get_aka[p]++;
		if( pat==22 || pat==34 || pat==38 ) get_ao[p]++;
		if( pat==35 ) get_kasu[p]++;
		if( pat==43 ) get_goko[p]--;
	}
	
	var yame = 0;
	
	if( get_kasu[0] >= 8 ) yame=1;	// カス８枚
	if( get_tan[0] >= 4 ) yame=2;	// 短冊４枚
	if( get_tane[0] >= 4 ) yame=3;	// タネ４枚

	// 赤短２枚(自分は０枚)
	if( get_aka[0] == 2 ){
		if( get_aka[1] == 0 ) yame=4;
	}
	// 青短２枚(自分は０枚)
	if( get_ao[0] == 2 ){
		if( get_ao[1] == 0 ) yame=5;
	}
	// 猪鹿２枚(自分は０枚)
	if( get_ino[0] == 2 ){
		if( get_ino[1] == 0 ) yame=6;
	}
	// 三光－雨２枚(自分は０枚)
	if( get_goko[0] == 2 ){
		if( get_goko[1] <= 0 ) yame=7;
	}

	if( yame>0 ){
		start_sum();
	}else{
		box.w = 10;
		box.h = 10;
		box.mw = 320;
		box.mh = 80;
		timer_func = koicombox;
	}
}

function koicombox(){
	if( !drawbox() ) return;
	
	context.textAlign = "center";
	context.font = "22px sans-serif";
	context.fillStyle = 'rgb(255,255,255)';
	context.fillText("こいこいします",SCREEN_WIDTH/2,SCREEN_HEIGHT/2+8);
	
	timer_func = null;
	click_func = koicom_click;
}

function koicom_click(){
	draw_fuda();
	click_func = null;
	after_player();
}

/////////////////////////////////
// タイトル
/////////////////////////////////

function start_title()
{
	 // 画面をクリア
	context.fillStyle = 'rgb(144,128,96)';
	context.fillRect(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);

	game.cnt = 0;
	timer_func = title_anime;
	click_func = null;
}

function title_anime()
{
	context.fillStyle = 'rgb(144,128,96)';
	context.fillRect(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);

	var i;
	var n = game.cnt;
	var cx = SCREEN_WIDTH/2;
	var cy = 440;
	var r = 160;
	
	for( i=0; i<12; i++ ){
		if( i>n ) continue;
		var pat = i*4+3;
		var sx = Math.floor(pat%10)*72;
		var sy = Math.floor(pat/10)*114;
		var t = Math.PI*i/11;
		var px = cx+r*Math.cos(t);
		var py = cy+r*Math.sin(t)/2;
		context.drawImage(img, sx,sy, FUDA_W, FUDA_H, px-FUDA_W/2,py-FUDA_H/2, FUDA_W, FUDA_H );
	}

	game.cnt++;
	if( game.cnt<24 ) return;
	
	// home
	context.drawImage(img_home, 0,0,48,48,8,8,48,48 );

	
	context.drawImage(title, 0,0,400,210, SCREEN_WIDTH/2-400/2,100, 400,210 );
		
	context.textAlign = "center";
	var py = 340;
	if( game.fuda_open ){
		context.font = "24px sans-serif";
		context.fillStyle = 'rgb(255,128,0)';
		context.fillText("裏面",SCREEN_WIDTH/2,py+30);
	}else{
	context.font = "16px sans-serif";
		context.fillStyle = 'rgb(255,255,255)';
		context.fillText("月見・花見はありません",SCREEN_WIDTH/2,py); py+=30;
		context.fillText("月札四枚で役になります",SCREEN_WIDTH/2,py); py+=30;
		context.fillText("50文でクリア",SCREEN_WIDTH/2,py); py+=30;
	}

	timer_func = null;
	click_func = title_click;
}

function title_click(){
	click_func = null;
	
	if( mouse.x<56 && mouse.y<56 ){
		location.href="http://gamedesign.jp/";
	}else{
		start_game();
	}
}

/////////////////////////////////
// エンディング
/////////////////////////////////

function start_ending()
{
	// 画面をクリア
	context.fillStyle = 'rgb(144,128,96)';
	context.fillRect(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	
	game.wait = 40;
	timer_func = start_hanabira;
	next_func = null;
}
	
function start_hanabira()
{
	game.wait--;
	if( game.wait>0 ) return;
	
	for( var i=0; i<50; i++ ){
		fuda[i].px = Math.random()*SCREEN_WIDTH;
		fuda[i].py = -500-Math.random()*3000;
		fuda[i].sc = 1-Math.random()*0.6;
	}
	game.kaze = 0;
	game.cnt = 0;
	timer_func = hanabira_anime;
	click_func = null;
}

function hanabira_anime()
{
	context.fillStyle = 'rgb(255,255,255)';
	context.fillRect(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	
	if( Math.random()<0.5 ){
		game.kaze += 0.1;
		if( game.kaze>5 ) game.kaze=5;
	}else{
		game.kaze -= 0.1;
		if( game.kaze<-5 ) game.kaze=-5;
	}
	for( var i=0; i<50; i++ ){
		fuda[i].px += game.kaze*fuda[i].sc;
		fuda[i].py += 10*fuda[i].sc;
		var sx = Math.floor(Math.random()*8)*60;
		var w = 60*fuda[i].sc;
		context.drawImage(hanabira, sx, 0, 60, 60, fuda[i].px, fuda[i].py, w, w );
		
		if( fuda[i].py>SCREEN_HEIGHT ){
			fuda[i].px = Math.random()*(SCREEN_WIDTH+100)-50;
			fuda[i].py = -60;
			fuda[i].sc = 1-Math.random()*0.6;
		}
	}
	
	game.cnt++;
	if( game.cnt>200 ){
		context.textAlign = "center";
		context.font = "48px sans-serif";
		context.fillStyle = 'rgb(0,0,0)';
		context.fillText("Congratulations!",SCREEN_WIDTH/2,SCREEN_HEIGHT/2);
	}
	
	if( game.cnt==200 ){
		click_func = start_title;
	}
}











